%global major 7.0
%global minor b10
%global commit f40a2c014cfd32eb6cc1e1c6c4264a0411fe0415
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global commitdate 20210610

%global project_name openjdk-asmtools

Name:           %{project_name}7
Version:        %{major}.%{minor}
Release:    1%{?dist}
Summary:        Set of tools used to assemble / disassemble proper and improper Java .class files for JDK version 11 and lesser

License:        GPLv2+
URL:            https://github.com/openjdk/asmtools
Source0:        https://github.com/openjdk/asmtools/archive/%{commit}/%{project_name}-%{shortcommit}.tar.xz
Source1:        openjdk-asmtools7.in
Source2:        openjdk-asmtools7.1

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

BuildRequires:  java-devel
BuildRequires:  maven-local
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-jar-plugin
Requires:  java-headless

%description
AsmTools helps develop tools to create proper and improper Java .class files.
Aids various Java .class based testing and OpenJDK development applications.
Asmtools supports latest class file formats, in lock-step with JDK development.
AsmTools consist of a set of (Java class file) assembler/dis-assemblers:
* Jasm/Jdis:
An assembler language to provide Java-like declaration of member signatures,
providing Java VM specification compliant mnemonics for byte-code instructions.
* JCod/JDec:
An assembler language to provide byte-code containers of class-file constructs.

This version works with JDK version 11 and lesser.

%package        javadoc
Summary:        Javadoc for %{name}

%description javadoc
This package contains the API documentation for %{name}.

%prep
%autosetup -n asmtools-%{commit}
cd maven
sed -i "s|ln -sv|cp -r|g" mvngen.sh
sh mvngen.sh
%pom_remove_plugin :maven-javadoc-plugin
%pom_remove_plugin :maven-source-plugin
%pom_remove_plugin :maven-gpg-plugin
sed "s/<addClasspath.*//" -i pom.xml
sed "s/<<mainClass.*//" -i pom.xml

%build
cd maven
%mvn_build --xmvn-javadoc

%install
rm -rf %{buildroot}
pushd maven
%mvn_install
popd

mkdir -p %{buildroot}%{_bindir}/
mkdir -p %{buildroot}%{_mandir}/man1/
install -d -m 755 %{buildroot}%{_bindir}
for launcher in "" "-jasm" "-jdis" "-jcoder" "-jdec" "-jcdec"; do
  switch=`echo $launcher |sed "s/-//"`
  cat %{SOURCE1} | sed "s/@SCD@/$switch/"  > %{buildroot}%{_bindir}/%{name}$launcher
done
install -d -m 755 %{buildroot}%{_mandir}/man1/
install -m 644 %{SOURCE2} %{buildroot}%{_mandir}/man1/

%files -f maven/.mfiles
%license LICENSE
%doc README.md
%attr(755, root, -) %{_bindir}/*
%{_mandir}/man1/openjdk-asmtools7.1*

%files javadoc -f maven/.mfiles-javadoc

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.0.b10-1
- initial build
